<?php
/**
 * @category    Zpayment
 * @package     Zpayment_Zpayment
 * @copyright   Copyright (c) 2014 Z-Payment (http://www.z-payment.com)
 */
class Zpayment_Zpayment_IndexController extends Mage_Core_Controller_Front_Action
{
    /**
     * Делает перенаправление на сайт Zpayment для осуществления оплаты.
     *
     * @access public
     * @return void
     */
    public function redirectAction()
    {
        $model = Mage::getModel('zpayment/payment');
        $data = $model->getRedirectFormFields();

        if (!empty($data)) {
            $this->importFromZpaymentLibrary('ZpaymentRequestPaymentForm');

            $form = new ZpaymentRequestPaymentForm();
            $form->setShopId($data['shopId']);
            $form->setShopPaymentId($data['paymentId']);
            $form->setAmount($data['amount']);
            $form->setUserEmail($data['userEmail']);
            $form->setPurpose($data['purpose']);
			$form->setZpsign($data['shopId'],$data['paymentId'],$data['amount'],$data['initPass']);
            echo $form->renderForm();

        } else
            $this->_redirect('checkout/cart');
    }

    /**
     * Обрабатывает оповещение об успешно проведенном платеже.
     *
     * @access public
     * @return void
     */
    public function ipnAction()
    {   
	    $request = Mage::app()->getRequest()->getPost();
        if($request['LMI_PREREQUEST']==1) {
		    echo 'YES';
        } else {
		    $model = Mage::getModel('zpayment/payment');
            $validationResult = $model->validateIpn($request);
            if ($validationResult === true) {
	            $order = Mage::getModel('sales/order')->loadByIncrementId($request['LMI_PAYMENT_NO']);
	            $order->setState(Mage_Sales_Model_Order::STATE_PROCESSING);
                $order->setStatus('processing');
                $order->setIsNotified(false);
	            $order->setStatus('complete');
                $order->save();
            } 
        }
    }

    public function cancelAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPaypalStandardQuoteId(true));
        if ($session->getLastRealOrderId()) {
            $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
            if ($order->getId()) {
                $order->cancel()->save();
            }
            Mage::helper('zpayment/checkout')->restoreQuote();
        }
        $this->_redirect('checkout/cart');
    }

    public function  successAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPaypalStandardQuoteId(true));
        Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();
        $this->_redirect('checkout/onepage/success', array('_secure'=>true));
    }


    private function importFromZpaymentLibrary($className)
    {
        $file = Mage::getBaseDir().DS.'lib'.DS.'zpaymentlib'.DS.$className.'.php';
        if (file_exists($file))
            require_once($file);
        else
            throw new Exception('Zpaymentlib: class '.$className.' not found');
    }
}
